(defpackage #:truth-table/base
  (:use #:common-lisp)
  (:export
   ;; parse.lsip
   #:whitespace-p
   #:paren-p
   #:delim-p
   #:symbol-char-p
   #:proposition-parse-error
   #:parse-error-position
   #:parse-error-proposition
   #:parse-error-message
   #:*operator-symbol-table*
   #:*operand-symbol-table*
   #:*operator-descriptions*
   #:operator-symbol
   #:operator-precedence
   #:interpret-operand
   #:next-token
   #:dotokens
   #:interpret-token
   #:parse-proposition-string

   ;; eval.lisp
   #:proposition-eval-error
   #:operator-argument-count
   #:logical-xor
   #:logical-and
   #:logical-or
   #:logical-implies
   #:eval-proposition

   ;; table.lisp
   #:discover-variables
   #:permute-variables
   #:create-truth-table
   #:extract-truth-table-expressions
   #:extract-truth-table-values
   #:combine-tables
   #:create-combined-truth-table

   ;; typeset.lisp
   #:table-format-error
   #:*operator-ascii-lookup-alist*
   #:*operator-unicode-lookup-alist*
   #:*operator-latex-lookup-alist*
   #:latex-var-name-transform
   #:flatten-proposition
   #:typeset-proposition
   #:convert-truth-table-to-latex
   #:convert-truth-table-to-html
   #:*table-border-ascii-alist*
   #:*table-border-unicode-alist*
   #:with-draw-table
   #:typeset-truth-table
   #:*known-formats*
   #:typeset-table-to-format))

(defpackage #:truth-table/args
  (:use #:common-lisp)
  (:export
   #:*cli-parse-continue-string*
   #:command-line-error
   #:cli-argument-error
   #:unknown-option-error
   #:option-no-arg-error
   #:no-input-error
   #:print-usage
   #:option-value
   #:parse-command-line))
